<!DOCTYPE html>
<html>

<head>
  <link rel="stylesheet" type="text/css" href="../assets/main.css" />
  <link rel="stylesheet" type="text/css" href="http://code.jquery.com/ui/1.9.1/themes/base/jquery-ui.css" />
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/stomp.js/2.3.3/stomp.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/sockjs-client/1.4.0/sockjs.min.js"></script>
  <script src="//code.jquery.com/ui/1.12.1/jquery-ui.js"></script>
</head>

<body>
  <div id="join" class="center_container">
    <div class="text_wrapper">
      <form onsubmit="submitJoin(event)">
        <h1> Choose a username:</h1>
        <input id="username" placeholder="user" />
      </form>
    </div>
  </div>


  <div id="lobby" class="h-center_container">
    <div class="content_container" id="main_content">
      <div id="user_list" class="userList">
      </div>
      <div class="suggestion_list">
        <div class="ready_btn">
          <button onclick="readyup()">
            <h1>Ready</h1>
          </button>
        </div>
        <form onsubmit="addGameToList(event)">
          <h1>Add a suggestion to your list:</h1>
          <input id="suggestion" oninput="searchGame()"/>
        </form>
        <div class="list">
          <ul id="listing" class="lists">
          </ul>
        </div>
      </div>
    </div>
  </div>

  <div id="result" class="h-center_container">
    <div class="list">
      <ul id="result_list" class="lists">
      </ul>
    </div>
  </div>

  <script src="../assets/configLoader.js"></script>
  <script>
    var lobbyId = new URLSearchParams(window.location.search).get('id');
    var config;
    var userId;
    var username;
    var suggestionList = [];
    var stompClient;
    var autocomplete = [];
    var games;

    $(document).ready(() => {

      if(localStorage.getItem("lobbyId") == lobbyId) {
        username = localStorage.getItem("username");
        userId = localStorage.getItem("userId");

        if(config == undefined) {
          $.getJSON("../configuration/config.json", (data) => {
            config = data;
          }).then(() => {
            setUpLobby();
          });
        } else {
          setUpLobby();
        }
      }
    })

    function submitJoin(e) {
      e.preventDefault();

      // Fetch the config
      $.getJSON("../configuration/config.json", (data) => {
        config = data;
      }).then(() => {
        // join the lobby
        username = $('#username').val()
        joinLobby();
      });
    }

    function joinLobby() {
      $.post({
        contentType: 'application/json',
        url: `${config.backendIp}api/lobby/${lobbyId}`,
        data: username,
        success: (data) => {

          userId = data;

          localStorage.setItem("userId", userId);
          localStorage.setItem("lobbyId", lobbyId);
          localStorage.setItem("username", $('#username').val());

          setUpLobby();
        }
      })
    }

    function setUpLobby() {
      $('#join').css("display", "none");
      $('#lobby').css("display", "flex");
      $('#result').css("display", "none");

      setAllUsers();
      setUpWebsocket({name: username, id: userId, lobId: lobbyId});
    }

    function setAllUsers() {
      $.get({
        url: `${config.backendIp}api/lobby/${lobbyId}/users`,
        success: (data) => {
          let users = data;
          users.forEach(user => {
            addUserToList(user.username, user.uuid);
          })
        }
      })
    }

    function addUserToList(username, uuid) {
      $('#user_list').html($('#user_list').html() + createUserHtml(username, uuid))
    }

    function createUserHtml(username, uuid) {
      return `<div class="user" id="${uuid}">
          <div class="user_icon not_ready">
            <h1>${username[0].toUpperCase()}</h1>
          </div>
          <div class="user_name">${username.slice(0,5)}</div>
      </div>`
    }

    function readyup() {
      $.ajax({
        url: `${config.backendIp}api/lobby/${lobbyId}/user/${userId}/list`,
        type: 'PUT',
        contentType: "application/json",
        data: JSON.stringify(suggestionList),
        success: response => {
          stompClient.send(`/ws/${lobbyId}`, {}, JSON.stringify({userUuid: userId, event: "READY_STATE_CHANGE", payload: username}));
        }
      })
    }

    function searchGame() {
      let input = $('#suggestion').val();
      input = input.trim();

      $.get({
        url: `${config.dbIp}games/search?title=${input}`,
        success: (data) => {
          games = data;
          autocomplete = [];
          games.forEach(game => {
            autocomplete.push(game.title);
          })

          $('#suggestion').autocomplete({
            source: autocomplete,
            appendTo: '#main_content'
          });
        }
      })

    }

    function addGameToList(e) {
      e.preventDefault();

      let input = document.getElementById('suggestion').value;
      // document.getElementById('suggestion').value = ""; 
      // ^ sollten wir das hier schon hier hinzufügen? Ist ein Zweischneidiges Schwert
      input = input.trim();
      if (input.length < 1) {
        return;
      } else if (autocomplete.includes(input)) {
        
        games.forEach(game => {
          if(game.title == input) {
            if(ArrayContainsObj(suggestionList, game)) {
              return; //if the game is already in the list abort mission and leave function;
            }
            suggestionList.push(game);

            list = document.getElementById('listing')
            list.innerHTML += "<li>" + input + "<button class='remove_btn' onclick='removeEntry(this)'>X</button></li>";

            document.getElementById('suggestion').value = "";
          }
        })
      }
    }


    /**
     * Helper function
     * there is no way to compare objects in javascript natively
     */
    function ArrayContainsObj(array, object) {
      let contains = array.some(elem => {
        return JSON.stringify(object) === JSON.stringify(elem);
      })
      return contains;
    }

    function removeEntry(entry){
      let entryElem = entry.parentElement
      let entryText = entryElem.textContent
      entryText = entryText.slice(0, entryText.length - 1);
      suggestionList = suggestionList.filter(suggestion => suggestion.title!== entryText);
      entryElem.remove();
    }

    function createResultList(games){
      resultList = $('#result_list');
      games.forEach(game => resultList.html(resultList.html() + `<li>${game.title}</li>`))

      $('#join').css("display", "none");
      $('#lobby').css("display", "none");
      $('#result').css("display", "flex");
    }
  </script>
  <script src="../assets/websocket.js"></script>
</body>

</html>